<?php

/**
 * @file
 * Contains \Drupal\editablevar\EditablevarExportForm.
 */

namespace Drupal\editablevar;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Url;

/**
 * Builds the form to export editablevars
 */
class EditablevarExportForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'editablevar_export_form';
  }
  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $data=[
      'data_type' => 'editablevars',
      'data_format' => 1,
      'data_timestamp' => date('c'),
      'data_host' => \Drupal::request()->getHost(),
      'data_comment' => '',
      'groups' => [],
    ];
    foreach ($groups = EditablevarGroupStorage::load() as $group) {
      $variables=[];
      foreach ($entries = EditablevarVarStorage::load(array('group_record_id' => $group->record_id)) as $var) {
        $variables[]=[
          'id' => $var->id,
          'value' => $var->value,
          'description' => $var->description,
        ];
      }

      $data['groups'][]=[
        'id' => $group->id,
        'name' => $group->name,
        'description' => $group->description,
        'source_file' => $group->source_file,
        'target_file' => $group->target_file,
        'json_file' => $group->json_file,
        'var_id_prefix' => $group->var_id_prefix,
        'variables' => $variables,
      ];
      
    }
    $form['export'] = array(
      '#type' => 'textarea',
      '#title' => t('Editablevar Export as JSON'),
      '#default_value' => json_encode($data, JSON_PRETTY_PRINT),
    );
    return $form;
  }
  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
  }
  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $form_state->setRedirectUrl(new Url('editablevar.group_list'));
  }

}
