<?php

/**
 * @file
 * Contains \Drupal\editablevar\Twig\EditablevarExtension.
 */

namespace Drupal\editablevar\TwigExtension;

use Twig\TwigFunction;
use Twig\Extension\AbstractExtension;

/**
 * Provides the Editablevar function within Twig templates.
 */
class EditablevarExtension extends AbstractExtension {

  /**
   * {@inheritdoc}
   */
  public function getName() {
    return 'editablevar';
  }

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return array(
      new TwigFunction('editablevar', [$this, 'editablevar'], [
        'is_safe' => ['html'],
      ]),
    );
  }

  /**
   * Provides editablevar() function to Twig templates.
   */
  public function editablevar($id, $default_value = '') {
    // use optional default value, if any given
    $output = $default_value;

    if (($id=='') || (!is_string($id) && !is_int($id))) {
      return $output;
    }
    if ($var = \Drupal\editablevar\EditablevarVarStorage::loadById($id)) {
      if (trim($var->value)!='') {
        $output = $var->value;
      }
    }
    return $output;
  }

}
